Package be.ehealth.technicalconnector.config

# Interface Configuration

All Known Subinterfaces:
  `ConfigValidator`

All Known Implementing Classes:
  `AbstractConfigurationImpl`, `ConfigurationImpl`, `ConfigurationWithSessionCache`, `ConfigValidatorImpl`

public interface Configuration
The interface that describes the configuration.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `containsKey(String key)`
  Property contains key.
  `Boolean`
  `getBooleanProperty(String key, Boolean defaultValue)`
  Gets the boolean property.
  `Configuration`
  `getCurrentConfig()`
  `Duration`
  `getDurationProperty(String key, Long defaultValue, TimeUnit defaultTimeUnit)`
  `Integer`
  `getIntegerProperty(String key, Integer defaultValue)`
  Gets the integer property.
  `Long`
  `getLongProperty(String key, Long defaultValue)`
  Gets the long property.
  `List<String>`
  `getMatchingProperties(String rootKey)`
  Gets the properties that match a root key.
  `String`
  `getProperty(String key)`
  Gets the property by Key from the DEFAULT_CONFIG.
  `String`
  `getProperty(String key, String defaultValue)`
  Gets the property by Key.
  `URL`
  `getURLProperty(String property)`
  Gets the uRL property.
  `boolean`
  `hasDurationProperty(String key)`
  `boolean`
  `hasMatchingProperty(String rootKey)`
  `boolean`
  `hasProperty(String key)`
  Checks for property.
  `void`
  `invalidate()`
  Method to invalidate all the cached configuration.
  `boolean`
  `isReloading()`
  `void`
  `reload()`
  Method to reload the configuration modules.
  `void`
  `setProperty(String key, String value)`
  Method to override a property at runtime.

- ## Method Details

  - ### getProperty

    String getProperty(String key, String defaultValue)
    Gets the property by Key.
    Parameters:
      `key` - the key
      `defaultValue` - the default value
    Returns:
      the property

  - ### getLongProperty

    Long getLongProperty(String key, Long defaultValue)
    Gets the long property.
    Parameters:
      `key` - the key
      `defaultValue` - the default value
    Returns:
      the long property

  - ### getIntegerProperty

    Integer getIntegerProperty(String key, Integer defaultValue)
    Gets the integer property.
    Parameters:
      `key` - the key
      `defaultValue` - the default value
    Returns:
      the integer property

  - ### getBooleanProperty

    Boolean getBooleanProperty(String key, Boolean defaultValue)
    Gets the boolean property.
    Parameters:
      `key` - the key
      `defaultValue` - the default value
    Returns:
      the boolean property

  - ### getProperty

    String getProperty(String key)
    Gets the property by Key from the DEFAULT_CONFIG.
    Parameters:
      `key` - the key
    Returns:
      the property

  - ### containsKey

    boolean containsKey(String key)
    Property contains key.
    Parameters:
      `key` - the key
    Returns:
      true, if successful

  - ### getURLProperty

    URL getURLProperty(String property)
    Gets the uRL property.
    Parameters:
      `property` - the string
    Returns:
      the uRL property

  - ### setProperty

    void setProperty(String key, String value)
    Method to override a property at runtime.
    Parameters:
      `key` - the key
      `value` - the value

  - ### hasProperty

    boolean hasProperty(String key)
    Checks for property.
    Parameters:
      `key` - the key
    Returns:
      true, if successful

  - ### hasMatchingProperty

    boolean hasMatchingProperty(String rootKey)

  - ### getDurationProperty

    Duration getDurationProperty(String key, Long defaultValue, TimeUnit defaultTimeUnit)

  - ### hasDurationProperty

    boolean hasDurationProperty(String key)

  - ### getMatchingProperties

    List<String> getMatchingProperties(String rootKey)
    Gets the properties that match a root key.
    Parameters:
      `rootKey` - the root key
    Returns:
      the properties

  - ### getCurrentConfig

    Configuration getCurrentConfig() throws TechnicalConnectorException
    Returns:
      the currenct configuration;
    Throws:
      `TechnicalConnectorException`

  - ### invalidate

    void invalidate() throws TechnicalConnectorException
    Method to invalidate all the cached configuration.
    Throws:
      `TechnicalConnectorException`

  - ### reload

    void reload() throws TechnicalConnectorException
    Method to reload the configuration modules.

    This method must be called when you change properties at runtime that are used by configuration modules.

    Throws:
      `TechnicalConnectorException`

  - ### isReloading

    boolean isReloading()